--- /tmp/t1	2016-08-31 23:36:48.969187000 +0200
+++ /tmp/t2	2016-08-31 23:47:42.061415000 +0200
@@ -7,15 +7,15 @@
 ACPI SDT: RSDP in kenv hint
 ACPI FADT: SCI irq 9, conform/conform
 MPTABLE: warning PCI int dst apic id 2 does not exist
-DragonFly v4.7.0.275.geee86d-DEVELOPMENT #16: Tue Aug 30 18:11:55 CEST 2016
+DragonFly v4.7.0.293.g173bd-DEVELOPMENT #18: Wed Aug 31 23:42:02 CEST 2016
     s@advancer.yo:/usr/obj/home/s/projects/dragonfly/src/sys/ADVANCER
 Calibrating clock(s) ...
-TSC clock: 3300152124 Hz (Method A)
-i8254 clock: 1193238 Hz
+TSC clock: 3300127164 Hz (Method A)
+i8254 clock: 1193229 Hz
 CLK_USE_I8254_CALIBRATION not specified - using default frequency
 CLK_USE_TSC_CALIBRATION not specified - using old calibration method
-TSC invariant clock: 3300010736 Hz
-CPU: Intel(R) Xeon(R) CPU E3-1226 v3 @ 3.30GHz (3300.01-MHz K8-class CPU)
+TSC invariant clock: 3300017488 Hz
+CPU: Intel(R) Xeon(R) CPU E3-1226 v3 @ 3.30GHz (3300.02-MHz K8-class CPU)
   Origin = "GenuineIntel"  Id = 0x306c3  Stepping = 3
   Features=0xbfebfbff<FPU,VME,DE,PSE,TSC,MSR,PAE,MCE,CX8,APIC,SEP,MTRR,PGE,MCA,CMOV,PAT,PSE36,CLFLUSH,DTS,ACPI,MMX,FXSR,SSE,SSE2,SS,HTT,TM,PBE>
   Features2=0x77fafbff<SSE3,PCLMULQDQ,DTES64,MON,DS_CPL,VMX,SMX,EST,TM2,SSSE3,SDBG,FMA,CX16,xTPR,PDCM,PCID,SSE4.1,SSE4.2,x2APIC,MOVBE,POPCNT,TSCDLT,AESNI,XSAVE,AVX,F16C,RDRND>
@@ -29,20 +29,20 @@
 Physical memory chunk(s):
 0x00020000 - 0x0007ffff, 393216 bytes (96 pages)
 0x00100000 - 0x001fffff, 1048576 bytes (256 pages)
-0x02de0000 - 0x03efffff, 17956864 bytes (4384 pages)
+0x02e00000 - 0x03efffff, 17825792 bytes (4352 pages)
 0x04000000 - 0xc693ffff, 3264479232 bytes (796992 pages)
 0xc6960000 - 0xc6d7ffff, 4325376 bytes (1056 pages)
 0xc7340000 - 0xd8c3ffff, 294649856 bytes (71936 pages)
 0xd8d00000 - 0xd8d3ffff, 262144 bytes (64 pages)
 0x100000000 - 0x41fd7ffff, 13419151360 bytes (3276160 pages)
-avail memory = 15980752896 (15240 MB)
+avail memory = 15980621824 (15240 MB)
 ACPI MADT: LAPIC address 0xfee00000, flags 0x1
 ACPI MADT: BSP apic id 0
 ACPI MADT: cpu id 0, acpi id 1, apic id 0
 ACPI MADT: cpu id 1, acpi id 2, apic id 2
 ACPI MADT: cpu id 2, acpi id 3, apic id 4
 ACPI MADT: cpu id 3, acpi id 4, apic id 6
-lapic: divisor index 0, frequency 50000081 Hz
+lapic: divisor index 0, frequency 50000111 Hz
 SMP: CPU0 apic_initialize():
      lint0: 0x00010700 lint1: 0x00000400 TPR: 0x00000000 SVR: 0x000001ff
 SMP: Waiting APs LAPIC initialization
@@ -176,26 +176,26 @@
 Active CPU Mask: 000000000000000f
 TSC testing MP synchronization ...
 cpu0: TSC testing MP synchronization ...
-cpu0: TSC is MP synchronized after 65470 tries
+cpu0: TSC is MP synchronized after 68677 tries
 cpu1: TSC testing MP synchronization ...
-cpu2: TSC testing MP synchronization ...
 cpu3: TSC testing MP synchronization ...
-cpu1: TSC is MP synchronized after 55943 tries
-cpu2: TSC is MP synchronized after 54741 tries
-cpu3: TSC is MP synchronized after 56857 tries
+cpu2: TSC testing MP synchronization ...
+cpu1: TSC is MP synchronized after 56136 tries
+cpu2: TSC is MP synchronized after 55865 tries
+cpu3: TSC is MP synchronized after 57217 tries
 TSC is MP synchronized
-TSC: cputimer freq 103125335, shift 5
-Preloaded elf kernel "kernel" at 0xffffffff826f9000.
-Preloaded elf obj module "if_tap.ko" at 0xffffffff826f9480.
-Preloaded elf obj module "snd_hda.ko" at 0xffffffff826f9d60.
-Preloaded elf obj module "sound.ko" at 0xffffffff826fa680.
-Preloaded elf obj module "acpi.ko" at 0xffffffff826fb020.
-Preloaded elf obj module "ehci.ko" at 0xffffffff826fb9b8.
-Preloaded elf obj module "xhci.ko" at 0xffffffff826fc210.
-Preloaded elf obj module "if_bridge.ko" at 0xffffffff826fcb28.
-Preloaded elf obj module "corepower.ko" at 0xffffffff826fd448.
-Preloaded elf obj module "ohci.ko" at 0xffffffff826fdc68.
-Preloaded elf obj module "uhci.ko" at 0xffffffff826fe4c0.
+TSC: cputimer freq 103125546, shift 5
+Preloaded elf kernel "kernel" at 0xffffffff82704000.
+Preloaded elf obj module "if_tap.ko" at 0xffffffff82704480.
+Preloaded elf obj module "snd_hda.ko" at 0xffffffff82704d60.
+Preloaded elf obj module "sound.ko" at 0xffffffff82705680.
+Preloaded elf obj module "acpi.ko" at 0xffffffff82706020.
+Preloaded elf obj module "ehci.ko" at 0xffffffff827069b8.
+Preloaded elf obj module "xhci.ko" at 0xffffffff82707210.
+Preloaded elf obj module "if_bridge.ko" at 0xffffffff82707b28.
+Preloaded elf obj module "corepower.ko" at 0xffffffff82708448.
+Preloaded elf obj module "ohci.ko" at 0xffffffff82708c68.
+Preloaded elf obj module "uhci.ko" at 0xffffffff827094c0.
 Bits within APICID: logical_CPU_bits: 1; core_bits: 3
 CPU Topology: cores_per_chip: 4; threads_per_core: 1; chips_per_package: 1;
 Start usched_dfly helpers on cpus:
@@ -1017,7 +1017,7 @@
 cpu0.acpi0.nexus0.root0
 cpu0: <ACPI CPU> [tentative] on acpi0
 ACPI: Dynamic OEM Table Load:
-ACPI: SSDT 0xFFFFFFE32BA12000 0003D3 (v01 PmRef  Cpu0Cst  00003001 INTL 20120711)
+ACPI: SSDT 0xFFFFFFE32B9F2000 0003D3 (v01 PmRef  Cpu0Cst  00003001 INTL 20120711)
 cpu_cst0.cpu0.acpi0.nexus0.root0
 cpu_cst0: <ACPI CPU C-State> [tentative] on cpu0
 C2: BitWidth(vendor) 1, BitOffset(class) 2, Address(arg0) 0x31, AccessWidth(arg1) 0x1
@@ -1553,47 +1553,37 @@
 da0: type 0xa5, start 63, end = 1953100799, size 1953100737 : OK
 no B_DEVMAGIC (bootdev=0)
 Mounting root from hammer:serno/E94AH4JZD6F9F8003F86.s1d
-HAMMER(ROOT) recovery check seqno=cd46d321
-HAMMER(ROOT) recovery range 3000000015ce4ed0-3000000015ce4ed0
-HAMMER(ROOT) recovery nexto 3000000015ce4ed0 endseqno=cd46d322
+HAMMER(ROOT) recovery check seqno=cdc8ced8
+HAMMER(ROOT) recovery range 30000000260a47d8-30000000260a47d8
+HAMMER(ROOT) recovery nexto 30000000260a47d8 endseqno=cdc8ced9
 HAMMER(ROOT) mounted clean, no recovery needed
 DMA space used: 42472k, remaining available: 131072k
 Mounting devfs
 start_init: trying /sbin/init
-kthread 0xffffffe1dd317c00 syncer6 has exited
-kthread 0xffffffe3246b5000 syncer7 has exited
-kthread 0xffffffe3246b5580 syncer8 has exited
-kthread 0xffffffe3246b4a80 syncer9 has exited
-kthread 0xffffffe3246b4a80 syncer10 has exited
-kthread 0xffffffe1dd318180 syncer11 has exited
-kthread 0xffffffe3246b5580 syncer12 has exited
+kthread 0xffffffe324695000 syncer6 has exited
+kthread 0xffffffe324695580 syncer7 has exited
+kthread 0xffffffe1dd317100 syncer8 has exited
+kthread 0xffffffe324694a80 syncer9 has exited
+kthread 0xffffffe1dd317c00 syncer10 has exited
+kthread 0xffffffe1dd317100 syncer11 has exited
+kthread 0xffffffe324694a80 syncer12 has exited
 cputimer: first power save request
 umass0: <Philips USB Flash Drive, class 0/0, rev 2.00/1.00, addr 2> on usbus0
-boundary check failed
 alignment check failed
-boundary check failed
 alignment check failed
-boundary check failed
 alignment check failed
-boundary check failed
 alignment check failed
-boundary check failed
 alignment check failed
-boundary check failed
 alignment check failed
 alignment check failed
 alignment check failed
 alignment check failed
 alignment check failed
-boundary check failed
 alignment check failed
-boundary check failed
 alignment check failed
 alignment check failed
 alignment check failed
-boundary check failed
 alignment check failed
-boundary check failed
 alignment check failed
 alignment check failed
 alignment check failed