--- /tmp/acpiexec.log2	2016-12-06 19:08:19.881022000 +0100
+++ /tmp/acpiexec.log	2016-12-06 19:01:56.284801000 +0100
@@ -1,7 +1,7 @@
-Script started on Tue Dec  6 19:07:49 2016
+Script started on Tue Dec  6 19:00:27 2016
 
 Intel ACPI Component Architecture
-AML Execution/Debug Utility version 20160930-64
+AML Execution/Debug Utility version 20161117-64
 Copyright (c) 2000 - 2016 Intel Corporation
 
 Input file apic.dat, Length 0x98 (152) bytes
@@ -25,11 +25,11 @@
 Input file uefi2.dat, Length 0x1B6 (438) bytes
 Input file xsdt.dat, Length 0xAC (172) bytes
 
-ACPI: RSDP 0x000000000047F600 000024 (v02 Intel )
-ACPI: XSDT 0x00000008007C00C0 0000C4 (v00 Intel  AcpiExec 00001001 INTL 20160930)
+ACPI: RSDP 0x000000000047F4C0 000024 (v02 Intel )
+ACPI: XSDT 0x00000008007C00C0 0000C4 (v00 Intel  AcpiExec 00001001 INTL 20161117)
 ACPI: FACP 0x00000008007000C0 00010C (v05 FUJ    PC       010D0000 FUJ  00000001)
 ACPI: DSDT 0x0000000800750000 00C351 (v02 FUJ    FJNB26F  010D0000 INTL 20120711)
-ACPI: FACS 0x000000000047F5C0 000040
+ACPI: FACS 0x000000000047F480 000040
 ACPI: APIC 0x00000008007200C0 000098 (v01 FUJ    PC       010D0000 FUJ  00000001)
 ACPI: ASF! 0x00000008007100C0 0000A5 (v32 FUJ    PC       010D0000 FUJ  00000001)
 ACPI: DMAR 0x0000000800710170 0000A8 (v01 FUJ    PC       010D0000 FUJ  00000001)
@@ -73,7 +73,7 @@
 
 No Arguments are initialized for method [_INI]
 
-ACPI Error: Method parse/execution failed [\_SB._INI] (Node 0x800830e70), AE_INVALID_TABLE_LENGTH (20160930/psparse-560)
+ACPI Error: Method parse/execution failed [\_SB._INI] (Node 0x800830e70), AE_INVALID_TABLE_LENGTH (20161117/psparse-560)
     Executed 7 _INI methods requiring 9 _STA executions (examined 126 objects)
 Unexpected AE_BAD_PARAMETER from AcpiInstallGpeHandler (aeexec-827)
 Unexpected AE_BAD_PARAMETER from AcpiEnableGpe (aeexec-830)
@@ -82,8 +82,8 @@
 - test predefined
 \_PR.CPU0._DEP                   returned AE_OK
 \_PR.CPU0._PPC                   returned AE_OK
-ACPI Warning: \_PR.CPU0._PCT: Missing expected return value (20160930/nsrepair-240)
-ACPI Warning: \_PR.CPU0._PCT: Expected return object of type Package (20160930/nspredef-310)
+ACPI Warning: \_PR.CPU0._PCT: Missing expected return value (20161117/nsrepair-240)
+ACPI Warning: \_PR.CPU0._PCT: Expected return object of type Package (20161117/nspredef-310)
 \_PR.CPU0._PCT                   returned AE_OK
 \_PR.CPU0._PSS                   returned AE_OK
 \_PR.CPU0._PSD                   returned AE_OK
@@ -119,7 +119,7 @@
 
 No Arguments are initialized for method [_INI]
 
-ACPI Error: Method parse/execution failed [\_SB._INI] (Node 0x800830e70), AE_INVALID_TABLE_LENGTH (20160930/psparse-560)
+ACPI Error: Method parse/execution failed [\_SB._INI] (Node 0x800830e70), AE_INVALID_TABLE_LENGTH (20161117/psparse-560)
 \_SB._INI                        returned AE_INVALID_TABLE_LENGTH
 \_SB.PCI0._HID                   returned AE_OK
 \_SB.PCI0._CID                   returned AE_OK
@@ -507,13 +507,20 @@
 \_S4                             returned AE_OK
 \_S5                             returned AE_OK
 \_PTS                            returned AE_OK
-[AcpiExec] Global:    Received a Device Notify on [CPU0] 0x800830ed0 Value 0x80 (Status Change)
-[AcpiExec] Handler 1: Received a Device Notify on [CPU0] 0x800830ed0 Value 0x80 (Status Change)
-[AcpiExec] Global:    Received a Device Notify on [CPU0] 0x800830ed0 Value 0x81 (Information Change)
-[AcpiExec] Handler 1: Received a Device Notify on [CPU0] 0x800830ed0 Value 0x81 (Information Change)
-\_WAK                            returned AE_OK
+ACPI Error: Needed type [Reference], found [Processor] 0x800864930 (20161117/exresop-114)
+ACPI Exception: AE_AML_OPERAND_TYPE, While resolving operands for [Notify] (20161117/dswexec-500)
+[AcpiExec] Exception AE_AML_OPERAND_TYPE during execution of method [PNOT] Opcode [Notify] @186
+[PNOT] @0017B #0086:  Notify (\_PR.CPU0, 0x80) // Status Change
+
+No Local Variables are initialized for method [PNOT]
+
+No Arguments are initialized for method [PNOT]
+
+ACPI Error: Method parse/execution failed [\PNOT] (Node 0x800841470), AE_AML_OPERAND_TYPE (20161117/psparse-560)
+ACPI Error: Method parse/execution failed [\_WAK] (Node 0x80084eeb0), AE_AML_OPERAND_TYPE (20161117/psparse-560)
+\_WAK                            returned AE_AML_OPERAND_TYPE
 \_S3                             returned AE_OK
 Evaluated 415 predefined names in the namespace
 - q
 
-Script done on Tue Dec  6 19:08:05 2016
+Script done on Tue Dec  6 19:00:54 2016