--- /tmp/t1	2014-08-03 01:07:06.330535000 +0200
+++ /tmp/t2	2014-08-03 01:10:55.599841000 +0200
@@ -10,7 +10,7 @@
 DragonFly v3.9.0.375.geccae-DEVELOPMENT #0: Sun Aug  3 00:29:07 CEST 2014
     s@vm64.yo:/usr/obj/home/s/projects/dragonfly/src/sys/X86_64_GENERIC
 Calibrating clock(s) ...
-TSC invariant clock: 3499834203 Hz, i8254 clock: 1193145 Hz
+TSC invariant clock: 3499765409 Hz, i8254 clock: 1193125 Hz
 CLK_USE_I8254_CALIBRATION not specified - using default frequency
 CLK_USE_TSC_CALIBRATION not specified - using old calibration method
 CPU: Intel(R) Core(TM) i7-4770K CPU @ 3.50GHz (3499.69-MHz K8-class CPU)
@@ -35,13 +35,13 @@
 ACPI MADT: cpu id 0, apic id 0
 ACPI MADT: cpu id 1, apic id 1
 ACPI MADT: cpu id 2, apic id 2
-lapic: divisor index 0, frequency 32996837 Hz
+lapic: divisor index 0, frequency 32996870 Hz
 SMP: CPU0 apic_initialize():
      lint0: 0x00000700 lint1: 0x00010400 TPR: 0x00000000 SVR: 0x000001ff
-SMI Frequency (worst case): 29411 Hz (34 us)
+SMI Frequency (worst case): 58823 Hz (17 us)
 SMP: Waiting APs LAPIC initialization
-SMP: CPU2 apic_initialize():
 SMP: CPU1 apic_initialize():
+SMP: CPU2 apic_initialize():
      lint0: 0x00010000 lint1: 0x00010400 TPR: 0x00000000 SVR: 0x000001ff
      lint0: 0x00010000 lint1: 0x00010400 TPR: 0x00000000 SVR: 0x000001ff
 ELCR Found.  ISA IRQs programmed as:
@@ -60,11 +60,12 @@
 Finish MP startup
 Active CPU Mask: 0000000000000007
 TSC testing MP synchronization ...
-TSC is not MP synchronized @6067
-Preloaded elf kernel "kernel" at 0xffffffff82a99000.
-Preloaded elf obj module "acpi.ko" at 0xffffffff82a992f0.
-Preloaded elf obj module "ehci.ko" at 0xffffffff82a99c88.
-Preloaded elf obj module "xhci.ko" at 0xffffffff82a9a4e0.
+TSC is MP synchronized, after 7296 tries
+TSC: cputimer freq 109365285, shift 5
+Preloaded elf kernel "kernel" at 0xffffffff82a9a000.
+Preloaded elf obj module "acpi.ko" at 0xffffffff82a9a2f0.
+Preloaded elf obj module "ehci.ko" at 0xffffffff82a9ac88.
+Preloaded elf obj module "xhci.ko" at 0xffffffff82a9b4e0.
 Bits within APICID: logical_CPU_bits: 0; core_bits: 2
 CPU Topology: cores_per_chip: 3; threads_per_core: 1; chips_per_package: 1;
 Start usched_bsd4 helpers on cpus:
@@ -170,16 +171,16 @@
 unknown: not probed (disabled)
 unknown: not probed (disabled)
 unknown: not probed (disabled)
-ACPI timer looks BAD  min = 1, max = 43, width = 42
-ACPI timer looks BAD  min = 1, max = 69, width = 68
-ACPI timer looks BAD  min = 1, max = 98, width = 97
-ACPI timer looks BAD  min = 1, max = 103, width = 102
-ACPI timer looks BAD  min = 1, max = 5, width = 4
-ACPI timer looks BAD  min = 1, max = 6, width = 5
-ACPI timer looks BAD  min = 1, max = 5, width = 4
-ACPI timer looks BAD  min = 1, max = 335, width = 334
-ACPI timer looks BAD  min = 1, max = 328, width = 327
-ACPI timer looks BAD  min = 1, max = 66, width = 65
+ACPI timer looks GOOD min = 1, max = 65, width = 64
+ACPI timer looks GOOD min = 1, max = 85, width = 84
+ACPI timer looks GOOD min = 1, max = 63, width = 62
+ACPI timer looks GOOD min = 1, max = 82, width = 81
+ACPI timer looks GOOD min = 1, max = 186, width = 185
+ACPI timer looks GOOD min = 1, max = 34, width = 33
+ACPI timer looks GOOD min = 1, max = 136, width = 135
+ACPI timer looks GOOD min = 1, max = 99, width = 98
+ACPI timer looks GOOD min = 1, max = 53, width = 52
+ACPI timer looks GOOD min = 1, max = 65, width = 64
 acpi_timer0.acpi0.nexus0.root0
 acpi_timer0: <24-bit timer at 3.579545MHz> [tentative] port 0x1008-0x100b on acpi0
 acpi_timer0: <24-bit timer at 3.579545MHz> [attached!] port 0x1008-0x100b on acpi0
@@ -714,8 +715,8 @@
 uhub0: <0x15ad UHCI root HUB, class 9/0, rev 1.00/1.00, addr 1> on usbus0
 usbus1.ehci0.pci2.pcib2.pci0.pcib0.acpi0.nexus0.root0
 usbus1: <EHCI (generic) USB 2.0 controller> [tentative] on ehci0
-usbus1: 480Mbps High Speed USB v2.0
-usbus1: <EHCI (generic) USB 2.0 controller> [attached!] on ehci0
+usbus1: usbus1: <EHCI (generic) USB 2.0 controller>480Mbps High Speed USB v2.0
+ [attached!] on ehci0
 ehci0: <EHCI (generic) USB 2.0 controller> [attached!] mem 0xfd5ef000-0xfd5effff irq 11 at device 3.0 on pci2
 pci2: <PCI bus> [attached!] on pcib2
 pcib2: <PCI-PCI bridge> [attached!] at device 17.0 on pci0
@@ -759,8 +760,8 @@
 xhci0: 32 byte context size.
 usbus2.xhci0.pci3.pcib3.pci0.pcib0.acpi0.nexus0.root0
 usbus2 [tentative] on xhci0
-usbus2 [attached!] on xhci0
-usbus2: 5.0Gbps Super Speed USB v3.0
+usbus2 [attached!]usbus2:  on xhci0
+5.0Gbps Super Speed USB v3.0
 xhci0: <XHCI (generic) USB 3.0 controller> [attached!] mem 0xfd4c0000-0xfd4dffff irq 16,10 at device 0.0 on pci3
 pci3: <PCI bus> [attached!] on pcib3
 pcib3: <PCI-PCI bridge> [attached!] at device 21.0 on pci0
@@ -894,9 +895,9 @@
 pci13.pcib13.pci0.pcib0.acpi0.nexus0.root0
 pci13: <PCI bus> [tentative] on pcib13
 pci13: domain=0, physical bus=13
-uhub2: 4 ports with 4 removable, self powered
 pci13: <PCI bus> [attached!] on pcib13
 pcib13: <PCI-PCI bridge> [attached!] at device 22.2 on pci0
+uhub2: 4 ports with 4 removable, self powered
 pcib14.pci0.pcib0.acpi0.nexus0.root0
 pcib14: <PCI-PCI bridge> [tentative] at device 22.3 on pci0
 pcib14:   domain            0
@@ -1226,7 +1227,6 @@
 atkbd0: <AT Keyboard> [attached!] irq 1 on atkbdc0
 psm0: current command byte:0047
 (probe0:ata1:0:0:0): Down reving Protocol Version from 2 to 0?
-uhub1: 6 ports with 6 removable, self powered
 uhub0: 2 ports with 2 removable, self powered
 psm0.atkbdc0.acpi0.nexus0.root0
 psm0: <PS/2 Mouse> [tentative] irq 12 on atkbdc0
@@ -1306,7 +1306,8 @@
 unknown: not probed (disabled)
 unknown: not probed (disabled)
 unknown: not probed (disabled)
-unknown: not probed (disabled)
+uhub1: unknown: 6 ports with 6 removable, self powered
+not probed (disabled)
 unknown: not probed (disabled)
 unknown: not probed (disabled)
 unknown: not probed (disabled)
@@ -1927,17 +1928,17 @@
 ATA PseudoRAID loaded
 ugen2.2: <Unknown> at usbus2 (disconnected)
 Mounting root from hammer:serno/00000000000000000001.s1d
-HAMMER(ROOT) recovery check seqno=003459e8
-HAMMER(ROOT) recovery range 3000000002fe8390-3000000002fe8390
-HAMMER(ROOT) recovery nexto 3000000002fe8390 endseqno=003459e9
+HAMMER(ROOT) recovery check seqno=00346745
+HAMMER(ROOT) recovery range 3000000003159b20-3000000003159b20
+HAMMER(ROOT) recovery nexto 3000000003159b20 endseqno=00346746
 HAMMER(ROOT) mounted clean, no recovery needed
 DMA space used: 3896k, remaining available: 16384k
 Mounting devfs
 start_init: trying /sbin/init
-kthread 0xffffffe02e7b5000 syncer6 has exited
-kthread 0xffffffe02e7b3f80 syncer7 has exited
-kthread 0xffffffe02e7b3f80 syncer8 has exited
-kthread 0xffffffe02e7b5580 syncer9 has exited
-kthread 0xffffffe02e7b3f80 syncer10 has exited
-kthread 0xffffffe02e7b3f80 syncer11 has exited
-kthread 0xffffffe02e7b5b00 syncer12 has exited
+kthread 0xffffffe084ea2180 syncer6 has exited
+kthread 0xffffffe084ea3200 syncer7 has exited
+kthread 0xffffffe084ea3200 syncer8 has exited
+kthread 0xffffffe02e7b4a80 syncer9 has exited
+kthread 0xffffffe084ea3200 syncer10 has exited
+kthread 0xffffffe084ea3200 syncer11 has exited
+kthread 0xffffffe02e7b5000 syncer12 has exited