--- /home/s/tmp/efi_map_fbsd	2016-10-29 21:06:36.000000000 +0200
+++ /home/s/tmp/efi_map_dfly	2016-10-29 21:06:53.000000000 +0200
@@ -15,40 +15,43 @@
              LoaderData 00003fffc000          0x0 00000004 UC WC WT WB 
      ConventionalMemory 000040000000          0x0 00000004 UC WC WT WB 
                Reserved 000040004000          0x0 00000001 UC WC WT WB 
-     ConventionalMemory 000040005000          0x0 0007b72b UC WC WT WB 
-             LoaderData 0000bb730000          0x0 00008000 UC WC WT WB 
+     ConventionalMemory 000040005000          0x0 0007d72b UC WC WT WB 
+             LoaderData 0000bd730000          0x0 00006000 UC WC WT WB 
        BootServicesData 0000c3730000          0x0 00000020 UC WC WT WB 
-     ConventionalMemory 0000c3750000          0x0 0000048b UC WC WT WB 
-             LoaderData 0000c3bdb000          0x0 0000216e UC WC WT WB 
+     ConventionalMemory 0000c3750000          0x0 000022f9 UC WC WT WB 
+             LoaderData 0000c5a49000          0x0 00000300 UC WC WT WB 
        BootServicesData 0000c5d49000          0x0 00000016 UC WC WT WB 
                Reserved 0000c5d5f000          0x0 00000202 UC WC WT WB 
        BootServicesData 0000c5f61000          0x0 000007bf UC WC WT WB 
-     ConventionalMemory 0000c6720000          0x0 0000003c UC WC WT WB 
-             LoaderData 0000c675c000          0x0 00000003 UC WC WT WB 
-     ConventionalMemory 0000c675f000          0x0 00000185 UC WC WT WB 
-             LoaderCode 0000c68e4000          0x0 00000090 UC WC WT WB 
-     ConventionalMemory 0000c6974000          0x0 00001bbb UC WC WT WB 
-       BootServicesData 0000c852f000          0x0 00000882 UC WC WT WB 
-     ConventionalMemory 0000c8db1000          0x0 0000052d UC WC WT WB 
-       BootServicesData 0000c92de000          0x0 0000236a UC WC WT WB 
+             LoaderData 0000c6720000          0x0 0000003f UC WC WT WB 
+     ConventionalMemory 0000c675f000          0x0 000001c7 UC WC WT WB 
+             LoaderCode 0000c6926000          0x0 0000004e UC WC WT WB 
+     ConventionalMemory 0000c6974000          0x0 000017ba UC WC WT WB 
+       BootServicesData 0000c812e000          0x0 00000c83 UC WC WT WB 
+     ConventionalMemory 0000c8db1000          0x0 000002d4 UC WC WT WB 
+       BootServicesData 0000c9085000          0x0 00000409 UC WC WT WB 
+     ConventionalMemory 0000c948e000          0x0 0000012d UC WC WT WB 
+       BootServicesData 0000c95bb000          0x0 0000208d UC WC WT WB 
      ConventionalMemory 0000cb648000          0x0 0000007f UC WC WT WB 
        BootServicesData 0000cb6c7000          0x0 000000ad UC WC WT WB 
      ConventionalMemory 0000cb774000          0x0 00000009 UC WC WT WB 
        BootServicesData 0000cb77d000          0x0 00000007 UC WC WT WB 
      ConventionalMemory 0000cb784000          0x0 00000001 UC WC WT WB 
        BootServicesData 0000cb785000          0x0 0000039e UC WC WT WB 
-     ConventionalMemory 0000cbb23000          0x0 0000001d UC WC WT WB 
-       BootServicesData 0000cbb40000          0x0 00000001 UC WC WT WB 
-     ConventionalMemory 0000cbb41000          0x0 00000001 UC WC WT WB 
-       BootServicesData 0000cbb42000          0x0 00000030 UC WC WT WB 
-     ConventionalMemory 0000cbb72000          0x0 0000005a UC WC WT WB 
-       BootServicesData 0000cbbcc000          0x0 00000076 UC WC WT WB 
-     ConventionalMemory 0000cbc42000          0x0 0000000d UC WC WT WB 
-       BootServicesData 0000cbc4f000          0x0 000003be UC WC WT WB 
-     ConventionalMemory 0000cc00d000          0x0 00000010 UC WC WT WB 
-       BootServicesData 0000cc01d000          0x0 0000133e UC WC WT WB 
-     ConventionalMemory 0000cd35b000          0x0 00002a84 UC WC WT WB 
-       BootServicesCode 0000cfddf000          0x0 0000857c UC WC WT WB 
+     ConventionalMemory 0000cbb23000          0x0 00000018 UC WC WT WB 
+       BootServicesData 0000cbb3b000          0x0 00000001 UC WC WT WB 
+     ConventionalMemory 0000cbb3c000          0x0 00000005 UC WC WT WB 
+       BootServicesData 0000cbb41000          0x0 0000000a UC WC WT WB 
+     ConventionalMemory 0000cbb4b000          0x0 0000004c UC WC WT WB 
+       BootServicesData 0000cbb97000          0x0 00000092 UC WC WT WB 
+     ConventionalMemory 0000cbc29000          0x0 00000027 UC WC WT WB 
+       BootServicesData 0000cbc50000          0x0 000003bd UC WC WT WB 
+     ConventionalMemory 0000cc00d000          0x0 00000003 UC WC WT WB 
+       BootServicesData 0000cc010000          0x0 0000000d UC WC WT WB 
+     ConventionalMemory 0000cc01d000          0x0 00000002 UC WC WT WB 
+       BootServicesData 0000cc01f000          0x0 0000133c UC WC WT WB 
+     ConventionalMemory 0000cd35b000          0x0 00002a93 UC WC WT WB 
+       BootServicesCode 0000cfdee000          0x0 0000856d UC WC WT WB 
     RuntimeServicesCode 0000d835b000          0x0 00000114 UC WC WT WB RUNTIME
     RuntimeServicesCode 0000d846f000          0x0 000000ec UC WC WT WB RUNTIME
     RuntimeServicesData 0000d855b000          0x0 000006a1 UC WC WT WB RUNTIME
@@ -57,8 +60,8 @@
                Reserved 0000dac46000          0x0 000002a9 UC WC WT WB 
           ACPIMemoryNVS 0000daeef000          0x0 0000002d UC WC WT WB 
           ACPIMemoryNVS 0000daf1c000          0x0 00000083 UC WC WT WB 
-      ACPIReclaimMemory 0000daf9f000          0x0 00000043 UC WC WT WB 
-      ACPIReclaimMemory 0000dafe2000          0x0 0000001d UC WC WT WB 
+      ACPIReclaimMemory 0000daf9f000          0x0 00000044 UC WC WT WB 
+      ACPIReclaimMemory 0000dafe3000          0x0 0000001c UC WC WT WB 
        BootServicesData 0000dafff000          0x0 00000001 UC WC WT WB 
      ConventionalMemory 000100000000          0x0 0011f600 UC WC WT WB 
                Reserved 0000000a0000          0x0 00000020 