Index: contrib/gcclibs/libgomp/config/linux/lock.c
===================================================================
--- contrib/gcclibs/libgomp/config/linux/lock.c	(revision 267872)
+++ contrib/gcclibs/libgomp/config/linux/lock.c	(working copy)
@@ -110,7 +110,7 @@
 void
 omp_init_nest_lock (omp_nest_lock_t *lock)
 {
-  memset (lock, 0, sizeof (lock));
+  memset (lock, 0, sizeof (*lock));
 }
 
 void
Index: contrib/gdb/gdb/jv-valprint.c
===================================================================
--- contrib/gdb/gdb/jv-valprint.c	(revision 267872)
+++ contrib/gdb/gdb/jv-valprint.c	(working copy)
@@ -110,24 +110,24 @@
 		element = next_element;
 	      else
 		{
-		  read_memory (address, buf, sizeof (buf));
+		  read_memory (address, buf, sizeof (buf) /* FIXME? */);
 		  address += TARGET_PTR_BIT / HOST_CHAR_BIT;
 		  /* FIXME: cagney/2003-05-24: Bogus or what.  It
                      pulls a host sized pointer out of the target and
                      then extracts that as an address (while assuming
                      that the address is unsigned)!  */
-		  element = extract_unsigned_integer (buf, sizeof (buf));
+		  element = extract_unsigned_integer (buf, sizeof (buf) /* FIXME? */);
 		}
 
 	      for (reps = 1; i + reps < length; reps++)
 		{
-		  read_memory (address, buf, sizeof (buf));
+		  read_memory (address, buf, sizeof (buf) /* FIXME? */);
 		  address += TARGET_PTR_BIT / HOST_CHAR_BIT;
 		  /* FIXME: cagney/2003-05-24: Bogus or what.  It
                      pulls a host sized pointer out of the target and
                      then extracts that as an address (while assuming
                      that the address is unsigned)!  */
-		  next_element = extract_unsigned_integer (buf, sizeof (buf));
+		  next_element = extract_unsigned_integer (buf, sizeof (buf) /* FIXME? */);
 		  if (next_element != element)
 		    break;
 		}
Index: contrib/ntp/ntpdc/ntpdc.c
===================================================================
--- contrib/ntp/ntpdc/ntpdc.c	(revision 267872)
+++ contrib/ntp/ntpdc/ntpdc.c	(working copy)
@@ -1503,7 +1503,7 @@
 	if (decodenetnum(hname, num)) {
 		if (fullhost != 0) {
 			getnameinfo((struct sockaddr *)num, sockaddr_len, 
-				    fullhost, sizeof(fullhost), NULL, 0, 
+				    fullhost, sizeof(fullhost) /* FIXME? */, NULL, 0, 
 				    NI_NUMERICHOST); 
 		}
 		return 1;
Index: contrib/ntp/ntpq/ntpq.c
===================================================================
--- contrib/ntp/ntpq/ntpq.c	(revision 267872)
+++ contrib/ntp/ntpq/ntpq.c	(working copy)
@@ -1744,7 +1744,7 @@
 	if (decodenetnum(hname, num)) {
 		if (fullhost != 0) {
 			getnameinfo((struct sockaddr *)num, sockaddr_len,
-					fullhost, sizeof(fullhost), NULL, 0,
+					fullhost, sizeof(fullhost) /* FIXME? */, NULL, 0,
 					NI_NUMERICHOST);
 		}
 		return 1;
Index: crypto/heimdal/lib/kadm5/ad.c
===================================================================
--- crypto/heimdal/lib/kadm5/ad.c	(revision 267872)
+++ crypto/heimdal/lib/kadm5/ad.c	(working copy)
@@ -1287,7 +1287,7 @@
 				 password,
 				 principal,
 				 &(*keys)[0]);
-	memset(password, 0, sizeof(password));
+	memset(password, 0, plen);
 	if (ret) {
 	    free(*keys);
 	    *keys = NULL;
Index: sys/dev/acpica/acpi_package.c
===================================================================
--- sys/dev/acpica/acpi_package.c	(revision 267872)
+++ sys/dev/acpica/acpi_package.c	(working copy)
@@ -80,7 +80,7 @@
     obj = &res->Package.Elements[idx];
     if (obj == NULL)
 	return (EINVAL);
-    bzero(dst, sizeof(dst));
+    bzero(dst, size);
 
     switch (obj->Type) {
     case ACPI_TYPE_STRING:
Index: sys/dev/nxge/if_nxge.c
===================================================================
--- sys/dev/nxge/if_nxge.c	(revision 267872)
+++ sys/dev/nxge/if_nxge.c	(working copy)
@@ -1495,7 +1495,7 @@
 	    case XGE_SET_BUFFER_MODE_2:
 	    case XGE_SET_BUFFER_MODE_5:
 	        *data = (*data == XGE_SET_BUFFER_MODE_1) ? 'Y':'N';
-	        if(copyout(data, ifreqp->ifr_data, sizeof(data)) == 0)
+		if(copyout(data, ifreqp->ifr_data, sizeof(data) /* FIXME? */) == 0)
 	            retValue = 0;
 	        break;
 	    default:
Index: sys/kern/kern_mutex.c
===================================================================
--- sys/kern/kern_mutex.c	(revision 267872)
+++ sys/kern/kern_mutex.c	(working copy)
@@ -836,7 +836,7 @@
 	 * requires Giant itself.
 	 */
 	if (!cold)
-		if (!kernacc((caddr_t)m, sizeof(m),
+		if (!kernacc((caddr_t)m, sizeof(*m),
 		    VM_PROT_READ | VM_PROT_WRITE))
 			panic("Can't read and write to mutex %p", m);
 #endif
Index: tools/regression/net80211/ccmp/test_ccmp.c
===================================================================
--- tools/regression/net80211/ccmp/test_ccmp.c	(revision 267872)
+++ tools/regression/net80211/ccmp/test_ccmp.c	(working copy)
@@ -680,7 +680,7 @@
 		printf("FAIL: decap botch; data does not compare\n");
 		printtest(t);
 		cmpfail(mtod(m, const void *), m->m_pkthdr.len,
-			t->plaintext, sizeof(t->plaintext));
+			t->plaintext, t_plaintext_len);
 		goto bad;
 	}
 	m_freem(m);
Index: tools/regression/net80211/wep/test_wep.c
===================================================================
--- tools/regression/net80211/wep/test_wep.c	(revision 267872)
+++ tools/regression/net80211/wep/test_wep.c	(working copy)
@@ -242,7 +242,7 @@
 	} else if (memcmp(mtod(m, const void *), t->plaintext, t->plaintext_len)) {
 		printf("FAIL: decap botch; data does not compare\n");
 		cmpfail(mtod(m, const void *), m->m_pkthdr.len,
-			t->plaintext, sizeof(t->plaintext));
+			t->plaintext, t->plaintext_len);
 		goto bad;
 	}
 
Index: tools/test/netfibs/reflect.c
===================================================================
--- tools/test/netfibs/reflect.c	(revision 267872)
+++ tools/test/netfibs/reflect.c	(working copy)
@@ -94,7 +94,7 @@
 		fprintf(stderr, "<< %s: %s\n", testcase, buf);
 
 	if (reflectfib != (u_int)-1)
-		l = snprintf(buf, sizeof(buf), "FIB %u\n", reflectfib);
+		l = snprintf(buf, buflen, "FIB %u\n", reflectfib);
 
 	/* If debug is on, log. */
 	if (debug > 0) {
Index: usr.bin/gzip/zuncompress.c
===================================================================
--- usr.bin/gzip/zuncompress.c	(revision 267872)
+++ usr.bin/gzip/zuncompress.c	(working copy)
@@ -145,7 +145,7 @@
 	else
 		compressed_pre = NULL;
 
-	while ((bin = fread(buf, 1, sizeof(buf), in)) != 0) {
+	while ((bin = fread(buf, 1, BUFSIZE, in)) != 0) {
 		if (tflag == 0 && (off_t)fwrite(buf, 1, bin, out) != bin) {
 			free(buf);
 			return -1;
Index: usr.bin/procstat/procstat_files.c
===================================================================
--- usr.bin/procstat/procstat_files.c	(revision 267872)
+++ usr.bin/procstat/procstat_files.c	(working copy)
@@ -114,7 +114,7 @@
 			snprintf(buffer, buflen, "%s.%d", buffer2,
 			    ntohs(sin6->sin6_port));
 		else
-			strlcpy(buffer, "-", sizeof(buffer));
+			strlcpy(buffer, "-", buflen);
 		break;
 
 	default: